@echo off

rem allocate and initialize the TurboBat err variable
set ERR=0 

rem if err has no value we don't have enuf environment space
if "%ERR%" == "" goto nospace

cls
echo ͸
echo  This batch file demonstrates the features of each TurboBat 1.0     
echo  utility program.  Each utility is used in a few different ways to  
echo  give you an idea how it looks and feels.  Remember, if you have    
echo  any suggestions to improve TurboBat just write to:                 
echo                                                                     
echo                          Russ A. Kelly                              
echo                         Custom Software                             
echo                       9239 Dunbarton Road                           
echo                         Santee Ca, 92071                            
echo ;

rem **********************************************************************
:namein

rem get the persons name
GETINPUT FULLNAME "Please Enter your full name : " S

rem if err=1 report out of env space
if "%ERR%" == "1" goto nospace

rem if they did not enter anything ... complain
if "%FULLNAME%" == "" goto noblank

rem edit the name just to trim leading and trailing blanks
EDITENV FULLNAME "" 0 "" 0- ST

rem if the result is null then the user just entered spaces
if "%FULLNAME%" == "" goto noblank

rem copy full name to working variables
SET FRSTNAME=%FULLNAME%
SET LASTNAME=%FULLNAME%
SET MIDLNAME=%FULLNAME%

rem if last copy did not work we are out of env space
if "%MIDLNAME%" == "" goto nospace

rem extract the first name (look for first space)
EDITENV FRSTNAME "" 0 " " -1 S

rem report the name break down
echo Hi %FRSTNAME%!  This is my break down of your entry :
echo 

rem report the first name
if not "%FRSTNAME%" == ""  echo     First Name : "%FRSTNAME%"

rem extract the middle name (btwn 1st and last space)
EDITENV MIDLNAME " " +1 " " -1- S

rem if one space is not found we have no middle name
if not "%ERR%" == "0" set MIDLNAME=

rem trim spaces in case user entered many spaces instead of name
EDITENV MIDLNAME "" 0 "" 0- ST

rem then report the middle name
if     "%MIDLNAME%" == ""  echo    Middle Name : "None"
if not "%MIDLNAME%" == ""  echo    Middle Name : "%MIDLNAME%"

rem extract last name (after last space)
EDITENV LASTNAME " " +1- "" 0- S
if not "%ERR%" == "0"      echo      Last Name : "None"
if     "%ERR%" == "0"      echo      Last Name : "%LASTNAME%"

rem clean up unnecessary variables
set FULLNAME=
set MIDLNAME=
set LASTNAME=

rem get out of name demo
goto namend

:noblank
echo Sorry I can't continue until you enter your name!
goto namein

:namend
echo 
GETINPUT A "Press Enter to continue ..." S
set A=

rem **********************************************************************

rem go on to next test
cls
echo ͸
echo  What you just saw was TurboBat's GETINPUT and EDITENV utilities in 
echo  action.  Here's what each one does:                                
echo                                                                    
echo    GETINPUT : Prompts the operator to enter input and stores that   
echo               input in an environment variable specified by the     
echo               user.                                                 
echo                                                                     
echo    EDITENV  : Edits/modifies the string value of an environment     
echo               variable based on user specified criteria.            
echo                                                                     
echo  These utilities can be more usefull than command line parameters   
echo  used by most batch files because they allow "dynamic" input and    
echo  modification of operator provided values.  You can create a batch  
echo  file that gets file names from the operator with GETINPUT.  You    
echo  can also edit the file names with EDITENV to make sure they have   
echo  the specified extension.                                           
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

cls
echo ͸
echo  All TurboBat utilities return an error code in the environment     
echo  variable ERR.  ERR is easier to use than ERRORLEVEL because you    
echo  can check it for a specific value.  You can even use ERR with      
echo  EDITENV to check for proper entries.                               
echo                                                                     
echo  Lets try an example.  I'll prompt you for a valid batch file name. 
echo  If its correct (it has a .bat extension) I'll tell you.  If not    
echo  you will get an error.  I will do this until you press Enter with  
echo  no input.  Remember, this is a simple example.  I'm not checking   
echo  for a valid path, the file name size or the existance of the file. 
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=
cls

rem **********************************************************************
:demo1

rem get the test input
GETINPUT IN "Enter a valid batch file name or press Enter to continue : " S

rem edit the file name just to trim leading and trailing blanks
EDITENV IN "" 0 "" 0- ST

rem if the result is null then the user wants to continue
if "%IN%" == "" goto end1

rem see if it has an extension, and convert to upper case
EDITENV IN "." 0- "" 0- SU

rem report status of extraction
if not "%ERR%" == "0" set IN=
if     "%IN%"  == "" goto noext
if not "%IN%"  == ".BAT" echo Sorry, "%IN%" is not a bat file extension
if     "%IN%"  == ".BAT" echo Great that extension is valid!
goto demo1

:noext
echo Sorry, this file name has no extension
goto demo1

:end1
rem clean up used variable
set IN=

:dodrive

cls
echo ͸
echo  As you can see GETINPUT and EDITENV can be very powerful in batch  
echo  file processing, but there are still two other useful user         
echo  interactive utilities, CHOICE and DRIVE.                           
echo                                                                     
echo  Here's what each one does:                                         
echo                                                                     
echo    CHOICE : Prompts the user to select a key corresponding to a     
echo             list of choices.  The operator is restricted to the     
echo             list given and the response is stored in the            
echo             environment variable specified.                         
echo                                                                     
echo    DRIVE  : Prompts the user to select a disk drive by letter and   
echo             stores the result in the environment variable           
echo             specified.  The drive type allowed can be restricted    
echo             to fixed or floppy disk.  The ERR environment variable  
echo             is set to an error value if an invalid entry is made.   
echo                                                                     
echo  These utilities are particularly usefull for installation batch    
echo  files that display menus and request drive designations.           
echo                                                                     
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

cls
echo ͸
echo  Lets demonstrate these utilities with a simple menu that allows    
echo  the user to select fixed, floppy or fixed and floppy drive letters.
echo  You select one of these three categories and I will ask you to     
echo  enter a valid drive letter for the category selected.  If your     
echo  entry is valid I will tell you.  If not, you will get an error.    
echo                                                                     
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

rem **********************************************************************
:demo2 

cls
echo ͸
echo                       Drive Category Menu                           
echo ;
echo 
echo  (F)ixed drive
echo  (R)emovable drive
echo  (B)oth drive types
echo  (Q)uit
echo  
CHOICE CHOICE FRBQ "Enter (F/R/B/Q) : " 

if "%CHOICE%" == "F" goto fixed
if "%CHOICE%" == "R" goto floppy
if "%CHOICE%" == "B" goto both
if "%CHOICE%" == "Q" goto end2
goto demo2

:fixed
echo 
DRIVE DRIVE F "Enter a valid fixed drive letter : " S
goto check

:floppy
echo 
DRIVE DRIVE R "Enter a valid floppy drive letter : " S
goto check

:both
echo 
DRIVE DRIVE B "Enter any valid drive letter : " S
goto check

:check
if "%ERR%" == "1" goto nospace 
if "%ERR%" == "5" goto badtype
if "%ERR%" == "6" goto invalid 
echo Good you entered drive %DRIVE%
goto done2

:invalid
echo Sorry drive %DRIVE% is invalid!
goto done2

:badtype
echo Sorry drive %DRIVE% is the wrong type of drive!

:done2
GETINPUT A "Press Enter to continue ..." S
set A=
goto demo2

:end2

rem **********************************************************************
:demo3

cls
echo ͸
echo  With the four utilities demonstrated you can add lots of power to  
echo  any batch file, but we have just two more TurboBat utilties that   
echo  can put the finishing touches on your batch file process,          
echo  EXIST and CURDIR.                                                  
echo                                                                     
echo  Here's what each one does:                                         
echo                                                                     
echo    EXIST  : Detects the existence of a file or directory and places 
echo             the result in the variable name specified.  "Y"         
echo             indicates the path exists, "N" indicates it does not.   
echo             You can also specify the attributes of the file or      
echo             directory you are looking for.  Wildcards are accepted. 
echo                                                                     
echo    CURDIR : Stores the entire path to the current working directory 
echo             in the environment variable specified.                  
echo                                                                     
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

cls
echo ͸
echo  The EXIST utility was designed because of the annoying DOS         
echo  inability to detect the existence of a directory as it does a file.
echo  The wildcard and attribute features were added to give it more     
echo  power.  The CURDIR utility was designed because of a need to pass  
echo  the current directory path as an argument to another program or    
echo  process.  The prime advantage is making the current directory path 
echo  available in the environment segment, which also allows it to be   
echo  manipulated by other TurboBat utilities.                           
echo                                                                     
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

cls
rem get current directory info
CURDIR CURDIR S
set DRIVE=%CURDIR%
set DNAME=%CURDIR%
if "%DNAME%" == "" goto nospace

rem extract specific values
EDITENV DRIVE ""   0  ":" 0  S
EDITENV DNAME "\\" +1- ""  0- S
if "%DNAME%" == "\" set DNAME=The root directory

rem display them in your message
echo As an example:
echo 
echo   your current directory is %CURDIR%.
echo   your current drive is %DRIVE%.
echo   the immediate directory is %DNAME%.  
echo 
echo All of this information was obtained by CURDIR and
echo extracted by EDITENV.
echo 

GETINPUT A "Press Enter to continue ..." S
set A=

cls
echo Now lets test the EXIST utility.  I will ask you to enter a 
echo file or directory path.  If you enter one that does not exist
echo I will tell you so.  Otherwise I will tell you it exists.

:demo3a
echo 
echo Enter a file or directory path  
GETINPUT A "or Q to quit : " S

rem trim off leading and trailing spaces
EDITENV A "" 0 "" 0- STU

if "%A%" == "Q" goto end3
EXIST EPATH %A% DSH S

if "%EPATH%" == "N" echo path %A% does not exist
if "%EPATH%" == "Y" echo path %A% is a valid path
goto demo3a

:end3
set A=

rem **********************************************************************
goto end

rem **********************************************************************
:nospace
echo Sorry you do not have enough environment space to run this demo!

rem **********************************************************************
:end

cls
echo ͸
echo  Well...That concludes our demo of the fabulous TurboBat utilities. 
echo  As you can see TurboBat has endless possiblities in batch file     
echo  processing.  To refresh your memory we have provided a quick       
echo  summary of utilities below and for even more inspiration we have   
echo  provided documentation for each TurboBat utility in TURBOBAT.DOC.  
echo                                                                     
echo  GETINPUT : Stores operator input in an environment variable        
echo  EDITENV  : Edits/modifies environment variable values              
echo  CHOICE   : Stores an operator choice in an environment variable    
echo  DRIVE    : Stores a verified drive choice in an enviroment variable
echo  EXIST    : Detects the existence of a file or directory            
echo  CURDIR   : Stores the entire path of the current working directory 
echo                                                                     
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=

cls
echo ͸
echo  If you end up using TurboBat please honor the Shareware concept    
echo  and register your TurboBat utilities (See TURBOBAT.DOC).  If you   
echo  have any other questions, comments or suggestions, send them to :  
echo                                                                     
echo                          Russ A. Kelly                              
echo                         Custom Software                             
echo                       9239 Dunbarton Road                           
echo                         Santee Ca, 92071                            
echo ;
GETINPUT A "Press Enter to continue ..." S
set A=


