/* SORTDIR.C    this program sorts a directory by renaming the files into a
ver 1.5         work directory, and reading them into an array, sorting the
                array, then renaming them back in sorted order. It allows 
                sorting by Name or Size, and you may default to sorting the
                current directory, or specify a directory as a command line
                param.
By Dan Kelley
4 Sylvan Court
Lakewood, NJ 08701
(908) 370-3209 Voice
(908) 370-3359 Top Gun II BBS (sysop) 14.4K baud HST
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <process.h>

void main(int argc, char* argv[])          /* argv[1] = field to sort on */
                                           /* "N" or "n" = name */
                                           /* "S" or "s" = size */
                                           /* default is "N" */
                                           /* argv[2] = directory to sort */
                                           /* default is current directory */
{
   int color=11;
   char filename[2000][12+1];              /* array to sort filenames */
   long filesize[2000];                    /* array to sort by size   */
   char order;                             /* sort order (N or S) */
   char Order[5];                          /* sort order by text (Name/Size) */
   char path[70];                          /* path of subdir to sort */
   int SourceRows=0;                       /* count files in current dir */
   unsigned int Row, SmallestRow, j;       /* for sorting array */
   char temp[12+1];                        /* for switching, in sort */
   long tempsize;                          /* for switching, in sort */
   struct ffblk ffblk;                     /* set up structure for getting filenames */
   int done;                               /* do while not done */
   char destdir[70];                       /* work directory */
   char command[80];                       /* DOS command */
   char sourcespec[70];                    /* hold sourcedir + filename */
   char destspec[70];                      /* hold tempdir + filename */
   char wildcard[70];                      /* hold tempdir + "*.*" */
   char test[70];                          /* test user input */
   textcolor(color++);
   cprintf("%s\r\n","SORTDIR.EXE  By Dan Kelley   v1.5");
   textcolor(color++);

   memset(filename,'\0',sizeof(filename)); /* clear array */
   memset(filesize,  0,sizeof(filesize));  /* clear array */
   memset(path,'\0',sizeof(path));         /* clear field */
   memset(test,'\0',sizeof(test));         /* clear field */

           /* set default of current directory */
   strcpy(path, "X:\\");                   /* set format for path display */
   path[0] = 'A' + getdisk();              /* find current drive */
   getcurdir(0, path+3);                   /* find current path on drive */

   order = 'N';                            /* set default of "sort by name" */

   if(argc == 2)                           /* if one command line param */
      {
      strcpy(test,(char*) argv[1]);        /* copy first argument to test */
      if(strcmp(test,"N")!=0  &&           /* if it's not N/n/S/s then it's */
         strcmp(test,"n")!=0  &&           /* the directory, and order */
         strcmp(test,"S")!=0  &&           /* remains at default of 'N' */
         strcmp(test,"s")!=0)
         strcpy(path,test);                /* copy user defined path to path */
      else
        if(strcmp(test,"S")==0 ||          /* if 'Ss' set order to 'S', else */
           strcmp(test,"s")==0)            /* leave at default of 'N'        */
	   order = 'S';
      }

   if(argc == 3)                           /* if two command line params */
      {
      strcpy(test,(char*) argv[1]);        /* copy user defined path to test */
      if(strcmp(test,"S")==0 ||            /* if 'Ss' set order to 'S', else */
         strcmp(test,"s")==0)              /* leave at default of 'N'        */
         order = 'S';
      strcpy(path,(char*) argv[2]);        /* copy user defined path to path */
      }

    if(order == 'N')                       /* display to user what directory */
      strcpy(Order,"Name");                /* and sort order is being used   */
    else
      strcpy(Order,"Size");
    cprintf("%s%s%s%s\r\n\r\n","Sorting ",path," by ",Order);
    textcolor(color++);

   if(strlen(path)==3)                     /* if root directory         */
     path[2] = '\0';                       /* remove trailing backslash */
   sprintf(wildcard,"%s%s",path,"\\*.*");  /* add "\*.*" to path */
   done=findfirst(wildcard,&ffblk,0);      /* read first filename */
   sprintf(destdir,"%s%s",path,"\\ZYXW\\");/* set name of temp directory */
   sprintf(command,"%s%s%s","MD ",path,"\\ZYXW");/* set DOS command to makedir */
   system(command);                        /* make temp directory under current */

   cprintf("%s\r\n","Reading directory ...");
   while(!done && SourceRows <= 2000)      /* move files to temp dir and add */
      {                                    /* filenames to array */
      SourceRows++;
      strcpy(filename[SourceRows],ffblk.ff_name); /* put filename in array */
      filesize[SourceRows] = ffblk.ff_fsize;      /* put filesize in array */
      memset(destspec,'\0',sizeof(destspec));     /* set destspec to nulls */
           /* copy path, '\', and filename to sourcespec */
      sprintf(sourcespec,"%s%s%s",path,"\\",ffblk.ff_name);
           /* copy path, '\', subdir, '\', and filename to destspec */
      sprintf(destspec,  "%s%s%s",path,"\\ZYXW\\",ffblk.ff_name);
           /* move file to subdirectory */
      rename(sourcespec,destspec);
      done=findnext(&ffblk); /* read next filename from disk */
      }
   textcolor(color++);
   cprintf("%s\r\n","Sorting directory ...");
   for (Row=1; Row<=SourceRows-1; Row++)                     /* sort array */
      {
      SmallestRow=Row;
      for(j=Row+1; j <= SourceRows; j++)
	      {
         if(order == 'N')                                    /* by Name /*
	        {
           if(strcmp(filename[j],filename[SmallestRow])<0)
	           SmallestRow=j;
           }
         else                                                /* by Size */
           if(filesize[j] < filesize[SmallestRow])
	           SmallestRow=j;
      }  /* for(j */
      /* found one smaller than the current one, so swap those two */
      if (SmallestRow > Row)
	      {
           /* next 3 lines switch filename */
	      strcpy(temp,filename[Row]);
	      strcpy(filename[Row],filename[SmallestRow]);
	      strcpy(filename[SmallestRow],temp);
           /* next 3 lines switch filesize */
	      tempsize = filesize[Row];
	      filesize[Row] = filesize[SmallestRow];
	      filesize[SmallestRow] = tempsize;
	      }
   }  /* end sort */

   textcolor(color++);
   cprintf("%s\r\n","Writing directory ...");
   for (Row=1; Row<=SourceRows; Row++)  /* move files back in sorted order */
       {
           /* copy path, subdir, filename to sourcespec */
       sprintf(sourcespec,"%s%s%s",path,"\\ZYXW\\",filename[Row]);
           /* copy path and filename to destspec */
       sprintf(destspec,"%s%s%s",path,"\\",filename[Row]);
           /* move the file from source to dest */
       rename(sourcespec,destspec);
       }
           /* set DOS command to RemoveDir */
   sprintf(command,"%s%s%s","RD ",path,"\\ZYXW");
   system(command);    /* remove temp directory */
}
